registerInputEvent(fxDtsBrick,"onRemoteTrigger","Self fxDtsBrick");
registerOutputEvent(fxDtsBrick,"setRemoteLink","bool",1);
registerOutputEvent(GameConnection,"clearRemoteLinks","",0);
function fxDtsBrick::setRemoteLink(%brick,%toggle,%client)
{
	if(%toggle)
	{
		if(!hasItemOnList(%client.remoteLink,%brick))
		{
			%client.remoteLink = addItemToList(%client.remoteLink,%brick);
		}
	}
	else
	{
		if(hasItemOnList(%client.remoteLink,%brick))
		{
			%client.remoteLink = removeItemFromList(%client.remoteLink,%brick);
		}
	}
}
function GameConnection::clearRemoteLinks(%client)
{
	%client.remoteLink = "";
}
function GameConnection::triggerRemoteLink(%client)
{
	for(%i=0;%i<getWordCount(%client.remoteLink);%i++)
	{
		%brick = getWord(%client.remoteLink,%i);
		if(isObject(%brick))
		{
			%brick.lastuserr = %client.player;
			%client.player.lasttelbrick = %brick;
			$inputTarget_Self = %brick;
			$inputTarget_Player = %client.player;
			$inputTarget_Client = %client;
			$inputTarget_Minigame = getMinigameFromObject(%client);
			%brick.processInputEvent("onRemoteTrigger",%client);
		}
	}
}
function addItemToList(%string,%item)
{
	if(hasItemOnList(%string,%item))
		return %string;

	if(%string $= "")
		return %item;
	else
		return %string SPC %item;
}
function hasItemOnList(%string,%item)
{
	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
			return 1;
	}
	return 0;
}
function removeItemFromList(%string,%item)
{
	if(!hasItemOnList(%string,%item))
		return %string;

	for(%i=0;%i<getWordCount(%string);%i++)
	{
		if(getWord(%string,%i) $= %item)
		{
			if(%i $= 0)
				return getWords(%string,1,getWordCount(%string));
			else if(%i $= getWordCount(%string)-1)
				return getWords(%string,0,%i-1);
			else
				return getWords(%string,0,%i-1) SPC getWords(%string,%i+1,getWordCount(%string));
		}
	}
}
datablock ItemData(RemoteItem : HammerItem)
{
	iconName = "";
	uiName = "Remote";
	image = RemoteImage;
	shapeFile = "./rcontrol.dts";
};
datablock ShapeBaseImageData(RemoteImage)
{
	shapeFile = "./rcontrol.dts";
   	emap = true;
	melee = false;
   	item = BowItem;
   	ammo = " ";
   	rojectile = "";
   	projectileType = "";
   	className = "WeaponImage";
  	 // for first person rendering.
   	mountPoint = 0;
   	offset = "0 0 0";
   	eyeOffset = 0; //"0.7 1.2 -0.5";
   	rotation = eulerToMatrix( "0 0 0" );	
	doColorShift = false;
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = false;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3] = "Smoke";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};
function RemoteImage::onFire(%this,%player,%slot)
{
	if(isObject(%player.client))
	{
		%player.client.triggerRemoteLink();
	}
}